package com.pqs9900.serviceImpl.HisData;

import com.pqs9900.mapper.HisData.DataHarmPhasicVMapper;
import com.pqs9900.pojo.HisData.DataHarmPhasicV;
import com.pqs9900.service.HisData.DataHarmPhasicVService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.concurrent.ThreadPoolTaskExecutor;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.Callable;
import java.util.concurrent.Future;

@Service
public class DataHarmPhasicVServiceImpl implements DataHarmPhasicVService {

    private static final Logger logger= LoggerFactory.getLogger(DataHarmPhasicVServiceImpl.class);

    @Autowired
    private ThreadPoolTaskExecutor taskExecutor;

    @Autowired
    private DataHarmPhasicVMapper dataHarmPhasicVMapper;
    @Override
    public int saveDataHarmPhasicV(DataHarmPhasicV dataHarmPhasicV) {
        return dataHarmPhasicVMapper.insert(dataHarmPhasicV);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public int insertDataHarmPhasicV(List<DataHarmPhasicV> list)  {
        return dataHarmPhasicVMapper.insertDataHarmPhasicV(list);
    }

    /**
     * 采用线程池进行数据入库
     * @param listDataHarmPhasicV 谐波电压角度数据
     */
    @Override
    public Future insertDataHarmPhasicVExecutor(List<DataHarmPhasicV> listDataHarmPhasicV) {
        int inum = 100 ;//每次解析入库条目数
        Callable callable = new Callable() {
            @Override
            public Object call() throws Exception {
                int nCyclicTimes;//循环次数（总长度/批量入库条目数）
                int fromIndex,toIndex;//获取数据的起始和结束下标
                try {
                    nCyclicTimes = (int) Math.ceil(listDataHarmPhasicV.size() / (double) inum);
                    List<DataHarmPhasicV> tmpListDataHarmPhasicV = new ArrayList<>();
                    for (int i = 0; i < nCyclicTimes; i++) {
                        tmpListDataHarmPhasicV.clear();
                        //假如是最后一次循环则获取循环到结束
                        fromIndex = i * inum;
                        if (i == nCyclicTimes - 1) {
                            toIndex = listDataHarmPhasicV.size();
                        } else {
                            toIndex = (i + 1) * inum;
                        }
                        //可以先按下标截取，再入库
                        tmpListDataHarmPhasicV.addAll(listDataHarmPhasicV.subList(fromIndex, toIndex));
                        // TODO 做批量入库的操作
                        dataHarmPhasicVMapper.insertDataHarmPhasicV(tmpListDataHarmPhasicV);
                    }
                    return "SUCCESS";
                } catch (Exception e) {
                    logger.error("谐波电压角度表导入异常，异常是" + e.toString());
                    return "FAIL";
                }
            }
        };
        return taskExecutor.submit(callable);
    }
}
